#lang north

-- @revision: e50ab485d8590ead53c2518396c04f81
-- @description: Creates some initial core tables for crossfire.
-- @up {
create table node(id integer primary key, name text not null, arch text not null,
                  type text check(type in ("client", "agent")) not null,
                  secret blob(32) not null)
-- }
-- @up {
create table node_resource(nodeid integer not null, resource text not null,
                           unique (nodeid, resource),
                           foreign key(nodeid) references node(id) on delete cascade);
-- }
-- @up {
create table task(id integer primary key, name text not null, manifest blob not null,
                  committed boolean not null default false,
                  complete boolean not null default false);
-- }
-- @up {
create table task_log(taskid integer not null, worker integer not null,
                      time_wall_start timestamp not null,
                      duration integer not null,
                      pattern blob not null,
                      foreign key (taskid) references task(id) on delete cascade,
                      foreign key (worker) references node(id) on delete restrict);
-- }
-- @up {
create table task_match(taskid integer not null, worker integer not null,
                        time_wall timestamp not null, match blob not null,
                        foreign key (taskid) references task(id) on delete cascade,
                        foreign key (worker) references node(id) on delete restrict);
-- }

-- @down {
drop table task_match;
-- }
-- @down {
drop table task_log;
-- }
-- @down {
drop table task;
-- }
-- @down {
drop table node_resource;
-- }
-- @down {
drop table node;
-- }
