#lang racket/base
;; crossfire: distributed brute force infrastructure
;;
;; Copyright (C) 2020 haskal
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU Affero General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU Affero General Public License for more details.
;;
;; You should have received a copy of the GNU Affero General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>.

(require racket/unit
         "comms.rkt")

(provide server^ agent^ client^)

(define-signature server^
  [get-agents
   new-agent
   edit-agent
   get-agent-deployment
   delete-agent
   new-project
   get-projects
   get-project-file
   get-project-matches
   delete-project
   agent-report-state])

(define-signature agent^
  [push-assignment
   cancel-assignment
   cancel-all-assignments])

(define-signature client^
  [todo])

(struct node-info [id name arch type resources online?] #:prefab)
;; manifest is the raw source format
(struct project-info [id name manifest progress matches] #:prefab)
(provide (struct-out node-info) (struct-out project-info))
